/**
 * Created by tonyjiang on 16/2/26.
 */
import Env from '../src/index'
import 'should'

describe('env-check 单元测试' , function(){

    let _windowMock = {
        navigator : {
            userAgent : ''
        }
    };


    //describe("由于判断使用浏览器环境,所以基于浏览器环境的分支不在测试范围中" , function(){});


    describe('浏览器环境检测' , function(){

        it("chrome浏览器下,Env.env.browser 的值应该为 Env.constant.browser.chrome" , function(){
            _windowMock.navigator.userAgent = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/48.0.2564.97 Safari/537.36";

            let envInstance = Env.getInstance(_windowMock);
            envInstance.window = _windowMock;
            envInstance.env.browser.should.equal(envInstance.constant.browser.chrome);
        });

        it("safari浏览器下,Env.env.browser 的值应该为 Env.constant.browser.safari" , function(){
            _windowMock.navigator.userAgent = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/600.8.9 (KHTML, like Gecko) Version/8.0.8 Safari/600.8.9";

            let envInstance = Env.getInstance(_windowMock);
            envInstance.window = _windowMock;
            envInstance.env.browser.should.equal(envInstance.constant.browser.safari);
        });

        it("firefox浏览器下,Env.env.browser 的值应该为 Env.constant.browser.firefox" , function(){
            _windowMock.navigator.userAgent = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:40.0) Gecko/20100101 Firefox/40.0";

            let envInstance = Env.getInstance(_windowMock);
            envInstance.window = _windowMock;
            envInstance.env.browser.should.equal(envInstance.constant.browser.firefox);
        });

        it("ie浏览器下,Env.env.browser 的值应该为 Env.constant.browser.ie" , function(){
            _windowMock.navigator.userAgent = "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; WOW64; Trident/4.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; InfoPath.3)";

            let envInstance = Env.getInstance(_windowMock);
            envInstance.window = _windowMock;
            envInstance.env.browser.should.equal(envInstance.constant.browser.ie);
        });

        it("opera浏览器下,Env.env.browser 的值应该为 Env.constant.browser.opera" , function(){
            _windowMock.navigator.userAgent = "Opera/9.80 (Windows NT 6.1; U; en) Presto/2.8.131 Version/11.11";

            let envInstance = Env.getInstance(_windowMock);
            envInstance.window = _windowMock;
            envInstance.env.browser.should.equal(envInstance.constant.browser.opera);
        });


    });

    describe("运行平台检测", function() {

        describe("微信平台下,Env.env.platform 的值应该为 Env.constant.platform.weixin", function () {
            it("iPhone", function () {
                _windowMock.navigator.userAgent = "Mozilla/5.0 (iPhone; CPU iPhone OS 5_1 like Mac OS X) AppleWebKit/534.46 (KHTML, like Gecko) Mobile/9B176 MicroMessenger/4.3.2";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.platform.should.equal(envInstance.constant.platform.weixin);
            });

            it("Android", function () {
                _windowMock.navigator.userAgent = "Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.platform.should.equal(envInstance.constant.platform.weixin);
            });

        });

        describe("chanjet平台下,Env.env.platform 的值应该为 Env.constant.platform.chanjet", function () {

            it("iPhone", function () {
                _windowMock.navigator.userAgent = "Mozilla/5.0 (iPhone; CPU iPhone OS 5_1 like Mac OS X) AppleWebKit/534.46 (KHTML, like Gecko) Mobile/9B176 chanjet";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.platform.should.equal(envInstance.constant.platform.chanjet);
            });

            it("Android", function () {
                _windowMock.navigator.userAgent = "Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 chanjet";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.platform.should.equal(envInstance.constant.platform.chanjet);
            });

        });

    });

    describe("运行操作系统检测" , function(){

        describe("ios操作系统下, Env.env.os 的值应该为 Env.constant.os.ios" , function(){

            it('iphone4' , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (iPhone; U; CPU iPhone OS 4_2_1 like Mac OS X; en-us) AppleWebKit/533.17.9 (KHTML, like Gecko) Version/5.0.2 Mobile/8C148 Safari/6533.18.5";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.ios);
            });

            it('iphone5' , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B137 Safari/601.1";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.ios);
            });

            it('iphone6' , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.ios);
            });

            it('iphone6Plus' , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.ios);
            });


        });

        describe('android操作系统下, Env.env.os 的值应该为 Env.constant.os.android' , function(){

            //小米, 红米, 联想 , meizu , 华为 ,oppo , 乐视

            it("Samsung Galaxy Note II" , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (Linux; U; Android 4.1; en-us; GT-N7100 Build/JRO03C) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.android);
            });

            it("Samsung Galaxy S4" , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (Linux; Android 4.2.2; GT-I9505 Build/JDQ39) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.android);
            });

            it("LG Optimus L70" , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (Linux; U; Android 4.4.2; en-us; LGMS323 Build/KOT49I.MS32310c) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.76 Mobile Safari/537.36";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.android);
            });

            it("小米3" , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (Linux; U; Android 4.4.4; zh-CN; MI 3W Build/KTU84P) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 UCBrowser/10.0.0.488 U3/0.8.0 Mobile Safari/534.30";
                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.android);
            });

        });



        describe("非ios和android系统下手机环境 , Env.env.os 的值应该为 Env.constant.os.mobile" , function(){

            it("BlackBerry" , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (BlackBerry; U; BlackBerry 9800; en) AppleWebKit/534.1+ (KHTML, like Gecko) Version/6.0.0.337 Mobile Safari/534.1+";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.mobile);
                            });

            it("BlackBerry Z30" , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (BB10; Touch) AppleWebKit/537.10+ (KHTML, like Gecko) Version/10.0.9.2372 Mobile Safari/537.10+";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.mobile);
            });

            //it("Nokia N97" , function(){
            //    _windowMock.navigator.userAgent = "Mozilla/5.0 (SymbianOS/9.4; Series60/5.0 NokiaN97-1/20.0.019; Profile/MIDP-2.1 Configuration/CLDC-1.1) AppleWebKit/525 (KHTML, like Gecko) BrowserNG/7.1.18124";
            //
            //    let envInstance = Env.getInstance(_windowMock);
            //    envInstance.window = _windowMock;
            //    envInstance.env.os.should.equal(envInstance.constant.os.mobile);
            //});

        });

        describe("电脑系统 , Env.env.os 的值应该为 Env.constant.os.computer" , function(){

            it("OS X Yosemite" , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/48.0.2564.97 Safari/537.36";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.computer);
            });

            it("windows7" , function(){
                _windowMock.navigator.userAgent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36";

                let envInstance = Env.getInstance(_windowMock);
                envInstance.window = _windowMock;
                envInstance.env.os.should.equal(envInstance.constant.os.computer);
            });


        });

    });

});